;WinGG, Windows for the Game Gear.
;Author: Victor Kemp, vkemp@paradise.net.nz 
;         or possibly vkemp@mcs.vuw.ac.nz
;         or failing those, ICQ 34431927.
;Date: November 1999

;If you think this code is a mess, I make no apologies, it serves you right
;for wasting your time reading somebody else's cheap-ass assembly program
;instead of going out and getting a job :)

.org  $0000
    nop                   ;nops just here because of a problem with byte 0
    nop                   ; of the EPROM.
    nop
    nop
    nop
    nop
    di                    ;Disable Interrupts
    im   1                ;Interrupt Mode 1
    jp   gui

.org  $0066               ;NMI interrupt routine for SMS pause button.
                          ;The Game Gear seems use this when its start
                          ;button is pressed too, contrary to a lot of
                          ;the documentation and emulators. But perhaps
                          ;it's just an electrical a fault in my dodgy
                          ;cartridge.

                          ;Cheap hack to make it more usable on a master
                          ; System. With this pressing the pause button will
                          ;  return to the GUI. We don't care that we're
                          ;   confusing the stack since everything is
                          ;    initialised again anyway.
    ld   hl,gui           ;
    push hl               ;

    retn

;============================================================================
;=============================\/= GUI =\/====================================
;============================================================================
.org $0100
gui:

    ld   sp,$c0ff         ;Set 256 byte stack

    ld   b,$c0
    call waitforline
                          ;Initialise the VDP registers.
    ld   hl,VDPRegsTable  ;
    ld   b,$0b            ;11 registers.
    ld   c,$80            ;Set VDP register address to 0 ($80+0)
VDPRegsLoop:              ;
    ld   a,(hl)           ;
    inc  hl               ;
    out  ($bf),a          ;Send data to register.
    ld   a,c              ;
    inc  c                ;
    out  ($bf),a          ;Send register address.
    dec  b                ;
    jr   nz,VDPRegsLoop   ;

                          ;Initialize RAM variables
    ld   a,127            ;
    ld   ($c100),a        ;cursor x coordinate
    ld   a,96             ;
    ld   ($c101),a        ;cursor y coordinate
    ld   a,48             ;
    ld   ($c102),a        ;scroll offset (96=left edge of SMS screen visible)

                          ;Set palette
    ld   a,0              ;Set CRAM address to $00 (color 0).
    out  ($bf),a          ;
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   hl,PaletteData   ;
    ld   c,64             ;Write 64 bytes to the palette registers for the
PaletteLoop:              ; 32 colors (2 bytes per palette entry).
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  c                ;
    ld   a,0              ;
    or   c                ;
    jr   nz,PaletteLoop   ;


                          ;Fill entire VRAM with zeros.
    ld   a,$00            ;Set VRAM address to $0000
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   bc,$4000         ;
ClearVRAMLoop:            ;
    ld   a,0              ;
    out  ($be),a          ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,ClearVRAMLoop ;


                          ;Transfer tiles to VRAM
    ld   a,$00            ;Set VRAM address to $0000 (tile images)
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   hl,TileData      ;
    ld   bc,TileCount     ;
TileLoop:                 ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send one byte of a tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,TileLoop      ;


                          ;Transfer tile numbers to VRAM
    ld   a,$00            ;Set VRAM address to $3800 (start of 1st SMS tile row)
    out  ($bf),a          ;
    ld   a,$78            ;
    out  ($bf),a          ;
    ld   hl,TileNums      ;
    ld   bc,768           ;32*24 tiles.
TileNumLoop:              ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send low byte, offset into tile definition table.
    ld   a,0              ;
    out  ($be),a          ;Send high byte, always 0.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,TileNumLoop   ;
    
                          ;Transfer sprites to VRAM
    ld   a,$00            ;Set VRAM address to $2000 (sprite images)
    out  ($bf),a          ;
    ld   a,$60            ;
    out  ($bf),a          ;
    ld   hl,SpriteData    ;
    ld   bc,SpriteCount   ;
SpriteLoop:               ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send one byte of a tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,SpriteLoop    ;


                          ;Turn on the Screen.
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   a,$81            ;
    out  ($bf),a          ;Write to VDP register 1.



EndlessLoop:

    ld   b,$c0            ;Wait for the end of the screen.
    call waitforline      ;



    in   a,($dc)          ;Read data from button port.

                          ;Load cursor coordinates from RAM.
    ld   hl,$c100         ;
    ld   b,(hl)           ;
    inc  hl               ;
    ld   c,(hl)           ;

                          ;Check for cursor keys pressed.
    bit  0,a              ;
    jr   nz,notup         ;
    dec  c                ;
    dec  c                ;
notup:                    ;
    bit  1,a              ;
    jr   nz,notdown       ;
    inc  c                ;
    inc  c                ;
notdown:                  ;
    bit  2,a              ;
    jr   nz,notleft       ;
    dec  b                ;
    dec  b                ;
notleft:                  ;
    bit  3,a              ;
    jr   nz,notright      ;
    inc  b                ;
    inc  b                ;
notright:                 ;

                          ;Make sure the curser is on the screen.
    ld   d,-1             ;
    ld   e,48             ;
    call isbbetween       ;
    cp   0                ;
    jr   z,leftedgeok     ;
    ld   b,48             ;
leftedgeok:               ;
    ld   d,-49            ;
    ld   e,0              ;
    call isbbetween       ;
    cp   0                ;
    jr   z,rightedgeok    ;
    ld   b,-49            ;
rightedgeok:              ;
    ld   d,-1             ;
    ld   e,24             ;
    call iscbetween       ;
    cp   0                ;
    jr   z,topedgeok      ;
    ld   c,24             ;
topedgeok:                ;
    ld   d,-89            ;
    ld   e,-64            ;
    call iscbetween       ;
    cp   0                ;
    jr   z,bottomedgeok   ;
    ld   c,-89            ;
bottomedgeok:             ;

                          ;Save cursor coordinates to RAM
    ld   hl,$c100         ;
    ld   (hl),b           ;
    inc  hl               ;
    ld   (hl),c           ;






    in   a,($dc)          ;Read data from button port.

    bit  4,a        
    jp   z,selectwaspressed
    bit  5,a        
    jp   z,selectwaspressed

    jp   selectnotpressed

selectwaspressed:


    ld   d,48
    ld   e,64
    call isbbetween
    cp   0
    jp   z,leftscrollnotpressed
    ld   d,-104
    ld   e,-88
    call iscbetween
    cp   0
    jp   z,leftscrollnotpressed

                          ;Update the scroll offset with new position.
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    inc  a                ;
    inc  a                ;
    cp   49               ;
    jp   m,leftscrollok   ;
    ld   a,48             ;
leftscrollok:             ;
    ld   (hl),a           ;


                          ;Set the left button to the pressed tiles.
    ld   a,$cc            ;Set VRAM address to top left tile of button.
    out  ($bf),a          ;    
    ld   a,$7c            ;
    out  ($bf),a          ;
    ld   a,9              ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,10             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,$0c            ;Set VRAM address to bottom left tile of button.
    out  ($bf),a          ;    
    ld   a,$7d            ;
    out  ($bf),a          ;
    ld   a,11             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,12             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;

    jp   scrollwaspressed

leftscrollnotpressed:



    ld   d,-80
    ld   e,-65
    call isbbetween
    cp   0
    jp   z,rightscrollnotpressed
    ld   d,-104
    ld   e,-88
    call iscbetween
    cp   0
    jp   z,rightscrollnotpressed

                          ;Update the scroll offset with new position.
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    dec  a                ;
    dec  a                ;
    ld   d,a              ;
    ld   a,-49            ;
    cp   d                ;
    ld   a,d              ;
    jp   m,rightscrollok  ;
    ld   a,-48            ;
rightscrollok:            ;
    ld   (hl),a           ;


                          ;Set the right button to the pressed tiles.
    ld   a,$ec            ;Set VRAM address to top left tile of button.
    out  ($bf),a          ;    
    ld   a,$7c            ;
    out  ($bf),a          ;
    ld   a,13             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,14             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,$2c            ;Set VRAM address to bottom left tile of button.
    out  ($bf),a          ;    
    ld   a,$7d            ;
    out  ($bf),a          ;
    ld   a,15             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;
    ld   a,16             ;
    out  ($be),a          ;
    ld   a,0              ;
    out  ($be),a          ;

    jp   scrollwaspressed

rightscrollnotpressed:

                          ;Check if paint icon was selected
    ld   d,16             ;
    ld   e,48             ;Compare with x coordinate of SMS screen
    push bc               ;
                          ;Subtract scroll offset from x coordinate
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    sub  b                ;
    neg                   ;
    ld   b,a              ;
    call isbbetween       ;
    pop  bc               ;
    cp   0                ;
    jp   z,paintnotpressed;
    ld   d,64             ;
    ld   e,112            ;
    call iscbetween       ;
    cp   0                ;
    jp   z,paintnotpressed;
                          ;
    jp   paint            ;Abandon everything and go to the paint program.
                          ;
paintnotpressed:          ;

                          ;Check if text icon was selected
    ld   d,80             ;
    ld   e,112            ;Compare with x coordinate of SMS screen
    push bc               ;
                          ;Subtract scroll offset from x coordinate
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    sub  b                ;
    neg                   ;
    ld   b,a              ;
    call isbbetween       ;
    pop  bc               ;
    cp   0                ;
    jp   z,textnotpressed ;
    ld   d,64             ;
    ld   e,112            ;
    call iscbetween       ;
    cp   0                ;
    jp   z,textnotpressed ;
                          ;
    jp   text             ;Abandon everything and go to the text program.
                          ;
textnotpressed:           ;

                          ;Check if animation icon was selected
    ld   d,144            ;
    ld   e,176            ;Compare with x coordinate of SMS screen
    push bc               ;
                          ;Subtract scroll offset from x coordinate
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    sub  b                ;
    neg                   ;
    ld   b,a              ;
    call isbbetween       ;
    pop  bc               ;
    cp   0                ;
    jp   z,anmnotpressed  ;
    ld   d,64             ;
    ld   e,112            ;
    call iscbetween       ;
    cp   0                ;
    jp   z,anmnotpressed  ;
                          ;
    jp   animation        ;Abandon everything and go to the animation program.
                          ;
anmnotpressed:            ;

                          ;Check if picture icon was selected
    ld   d,208            ;
    ld   e,240            ;Compare with x coordinate of SMS screen
    push bc               ;
                          ;Subtract scroll offset from x coordinate
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    sub  b                ;
    neg                   ;
    ld   b,a              ;
    call isbbetween       ;
    pop  bc               ;
    cp   0                ;
    jp   z,picnotpressed  ;
    ld   d,64             ;
    ld   e,112            ;
    call iscbetween       ;
    cp   0                ;
    jp   z,picnotpressed  ;
                          ;
    jp   picture          ;Abandon everything and go to the picture program.
                          ;
picnotpressed:            ;


selectnotpressed:

                          ;Set the left button to the non-pressed tiles.
    ld   a,$cc            ;Set VRAM address to top left tile of button.
    out  ($bf),a          ;    
    ld   a,$7c            ;
    out  ($bf),a          ;
    ld   a,1
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,2
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,$0c            ;Set VRAM address to bottom left tile of button.
    out  ($bf),a          ;    
    ld   a,$7d            ;
    out  ($bf),a          ;
    ld   a,3
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,4
    out  ($be),a
    ld   a,0
    out  ($be),a


                          ;Set the right button to the non-pressed tiles.
    ld   a,$ec            ;Set VRAM address to top left tile of button.
    out  ($bf),a          ;    
    ld   a,$7c            ;
    out  ($bf),a          ;
    ld   a,5
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,6
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,$2c            ;Set VRAM address to bottom left tile of button.
    out  ($bf),a          ;    
    ld   a,$7d            ;
    out  ($bf),a          ;
    ld   a,7
    out  ($be),a
    ld   a,0
    out  ($be),a
    ld   a,8
    out  ($be),a
    ld   a,0
    out  ($be),a


scrollwaspressed:



                          ;Load cursor coordinates from RAM.
    ld   hl,$c100         ;
    ld   b,(hl)           ;
    inc  hl               ;
    ld   c,(hl)           ;

                          ;Set x coordinate and tile number of cursor sprites.
    ld   a,$80            ;Set VRAM address
    out  ($bf),a          ;
    ld   a,$7F            ;
    out  ($bf),a          ;
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,4              ;
    out  ($be),a          ;tile number (top left)
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,5              ;
    out  ($be),a          ;tile number (middle left)
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,6              ;
    out  ($be),a          ;tile number (bottom left)
    ld   a,b              ;
    add  a,8              ;
    ld   b,a              ;
    out  ($be),a          ;x pos
    ld   a,7              ;
    out  ($be),a          ;tile number (top right)
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,8              ;
    out  ($be),a          ;tile number (middle right)
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,9              ;
    out  ($be),a          ;tile number (bottom right)


                          ;Set y coordinate of cursor sprites.
    ld   a,$00            ;Set VRAM address
    out  ($bf),a          ;
    ld   a,$7F            ;
    out  ($bf),a          ;
    ld   a,c              ;
    sub  1                ;The sprite will end up at 1 + the coordinate set.
    out  ($be),a          ;y pos (top left)
    add  a,8              ;
    out  ($be),a          ;y pos (middle left)
    add  a,8              ;
    out  ($be),a          ;y pos (bottom left)
    ld   a,c              ;
    sub  1                ;The sprite will end up at 1 + the coordinate set.
    out  ($be),a          ;y pos (top right)
    add  a,8              ;
    out  ($be),a          ;y pos (middle right)
    add  a,8              ;
    out  ($be),a          ;y pos (bottom right)




                          ;Scroll position indicator.
                          ;Load scroll position from RAM.
    ld   hl,$c102         ;
    ld   a,(hl)           ;
    neg                   ;Convert scroll pos to scroll indicator position.
    add  a,112            ;
    ld   b,a              ;

                          ;Set x coordinate and tile number
    ld   a,$8C            ;Set VRAM address
    out  ($bf),a          ;
    ld   a,$7F            ;
    out  ($bf),a          ;
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,0              ;
    out  ($be),a          ;tile number (top left)
    ld   a,b              ;
    out  ($be),a          ;x pos
    ld   a,1              ;
    out  ($be),a          ;tile number (bottom left)
    ld   a,b              ;
    add  a,8
    out  ($be),a          ;x pos
    ld   a,2              ;
    out  ($be),a          ;tile number (top right)
    ld   a,b              ;
    add  a,8
    out  ($be),a          ;x pos
    ld   a,3              ;
    out  ($be),a          ;tile number (bottom right)

    ld   a,$06            ;Set VRAM address to y-coordinates
    out  ($bf),a          ;
    ld   a,$7f            ;
    out  ($bf),a          ;
    ld   a,151
    out  ($be),a
    ld   a,159
    out  ($be),a
    ld   a,151
    out  ($be),a
    ld   a,159
    out  ($be),a





                          ;Horozontal scroll
    ld   hl,$c102         ;
    ld   a,(hl)           ;Read scroll offset from RAM
    out  ($bf),a          ;
    ld   a,$88            ;
    out  ($bf),a          ;Write to VDP register 8.
                          ;
    ld   b,151            ;Stop scrolling at the scroll bar.
    call waitforline      ;
    ld   a,0              ;
    out  ($bf),a          ;
    ld   a,$88            ;
    out  ($bf),a          ;Write to VDP register 8.



    jp   EndlessLoop






TileData: 
.include tiles
TileEnd:
TileCount = TileEnd-TileData

TileNums:
.include tilenums

SpriteData:
.include sprites
SpriteEnd:
SpriteCount = SpriteEnd-SpriteData


;============================================================================
;=============================/\= GUI =/\====================================
;============================================================================

;============================================================================
;============================\/= PAINT =\/===================================
;============================================================================
paint:

    ld   sp,$c0ff         ;Set 256 byte stack

    ld   b,$c0
    call waitforline
                          ;Initialise the VDP registers.
    ld   hl,VDPRegsTable  ;
    ld   b,$0b            ;11 registers.
    ld   c,$80            ;Set VDP register address to 0 ($80+0)
PNTVDPRegsLoop:           ;
    ld   a,(hl)           ;
    inc  hl               ;
    out  ($bf),a          ;Send data to register.
    ld   a,c              ;
    inc  c                ;
    out  ($bf),a          ;Send register address.
    dec  b                ;
    jr   nz,PNTVDPRegsLoop;

                          ;Initialize RAM variables
    ld   a,127            ;
    ld   ($c100),a        ;cursor x coordinate
    ld   a,96             ;
    ld   ($c101),a        ;cursor y coordinate

                          ;Set palette
    ld   a,0              ;Set CRAM address to $00 (color 0).
    out  ($bf),a          ;
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   hl,PaletteData   ;
    ld   c,64             ;Write 64 bytes to the palette registers for the
PNTPaletteLoop:           ; 32 colors (2 bytes per palette entry).
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  c                ;
    ld   a,0              ;
    or   c                ;
    jr   nz,PNTPaletteLoop;

                          ;Fill entire VRAM with zeros.
    ld   a,$00            ;Set VRAM address to $0000
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   bc,$4000         ;
PNTClearVRAMLoop:         ;
    ld   a,0              ;
    out  ($be),a          ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,PNTClearVRAMLoop ;

                          ;Set all the tiles to consecutive tile numbers.
    ld   a,$cc            ;Set VRAM address to $38cc (start of 1st tile row)
    out  ($bf),a          ;
    ld   a,$78            ;
    out  ($bf),a          ;
                          ;
    ld   c,0              ;c counts the row number of tiles (0-17)
ScreenLoop2:              ;
                          ;
    ld   b,0              ;b is the column number (0-19)
ScreenLoop1:              ;
                          ;
    push bc               ;hl = 20 * c
    ld   b,0              ;Is it just me or is there no multiply instruction
    ld   hl,0             ;on the Z80?!!? And to really twist the knife
    ld   a,20             ;there's no 16 bit left shift instruction to use
MulLoop1:                 ;instead either! Well using a loop is still a
    add  hl,bc            ;pretty slow way to multiply but it's easy.
    dec  a                ;
    cp   0                ;
    jr   nz,MulLoop1      ;
    pop  bc               ;
                          ;
    push bc               ;hl = hl + b
    ld   c,b              ;
    ld   b,0              ;
    add  hl,bc            ;
    pop  bc               ;
                          ;
    ld   a,l              ;Write tile number (hl) to VRAM
    out  ($be),a          ;
    ld   a,h              ;
    out  ($be),a          ;
                          ;
    inc  b                ;Move to the next tile along
    ld   a,b              ;
    cp   20               ;
    jr   nz,ScreenLoop1   ;
                          ;
    ld   d,24             ;Add 6 tiles off right hand side of current row
EdgeFillLoop:             ;and 6 off left hand side of the next row.
    ld   a,0              ;
    out  ($be),a          ;
    dec  d                ;
    ld   a,0              ;
    cp   d                ;
    jr   nz,EdgeFillLoop  ;
                          ;
    inc  c                ;Move to the next row of tiles.
    ld   a,c              ;
    cp   18               ;
    jr   nz,ScreenLoop2   ;


                          ;Set tile number of cursor
    ld   a,$80            ;Set VRAM address
    out  ($bf),a          ;
    ld   a,$7F            ;
    out  ($bf),a          ;
    ld   a,0              ;
    out  ($be),a          ;x pos
    ld   a,191            ;
    out  ($be),a          ;tile number



                          ;Load crosshair cursor tile into VRAM
    ld   a,$e0            ;Set VRAM address to $37e0 (tile 447 image)
    out  ($bf),a          ;
    ld   a,$77            ;
    out  ($bf),a          ;
    ld   hl,crosshairdata ;
    ld   bc,32            ;32 bytes in the tile
PNTTileLoop:              ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send one byte of the tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,PNTTileLoop   ;


                          ;Turn on the Screen.
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   a,$81            ;
    out  ($bf),a          ;Write to VDP register 1.


PNTloop:


    ld   b,$c0            ;
    call waitforline      ;Wait for the end of the screen.
    ld   b,$bf            ;
    call waitforline      ;Wait again to make the cursor easier to control.


    in   a,($00)          ;Read data from start button port.
    bit  7,a        
    jp   z,gui            ;Reload the GUI



    in   a,($dc)          ;Read data from button port.

                          ;Load cursor coordinates from RAM.
    ld   hl,$c100         ;
    ld   b,(hl)           ;
    inc  hl               ;
    ld   c,(hl)           ;

                          ;Check for cursor keys pressed.
    bit  0,a              ;
    jr   nz,PNTnotup      ;
    dec  c                ;
PNTnotup:                 ;
    bit  1,a              ;
    jr   nz,PNTnotdown    ;
    inc  c                ;
PNTnotdown:               ;
    bit  2,a              ;
    jr   nz,PNTnotleft    ;
    dec  b                ;
PNTnotleft:               ;
    bit  3,a              ;
    jr   nz,PNTnotright   ;
    inc  b                ;
PNTnotright:              ;

                          ;Make sure the curser is on the screen.
    ld   d,-1             ;
    ld   e,48             ;
    call isbbetween       ;
    cp   0                ;
    jr   z,PNTleftedgeok  ;
    ld   b,48             ;
PNTleftedgeok:            ;
    ld   d,-49            ;
    ld   e,0              ;
    call isbbetween       ;
    cp   0                ;
    jr   z,PNTrightedgeok ;
    ld   b,-49            ;
PNTrightedgeok:           ;
    ld   d,-1             ;
    ld   e,24             ;
    call iscbetween       ;
    cp   0                ;
    jr   z,PNTtopedgeok   ;
    ld   c,24             ;
PNTtopedgeok:             ;
    ld   d,-90            ;
    ld   e,-64            ;
    call iscbetween       ;
    cp   0                ;
    jr   z,PNTbottomedgeok;
    ld   c,-90            ;
PNTbottomedgeok:          ;

                          ;Save cursor coordinates to RAM
    ld   hl,$c100         ;
    ld   (hl),b           ;
    inc  hl               ;
    ld   (hl),c           ;



    in   a,($dc)          ;Read data from button port.
                          ;Check for either button 1 or 2.
    bit  4,a              ;
    jp   z,PNTpaintpressed;
    bit  5,a              ;
    jp   z,PNTpaintpressed;
    jp   PNTpaintnotpressed;
PNTpaintpressed:

                          ;Put a dot in the appropriate tile.
    ;Tile image number = 20 * (y SHR 3) + (x SHR 3) - 66

                          ;Load cursor y coordinate from RAM.
    ld   hl,$c101         ;
    ld   a,(hl)           ;
    ld   c,a              ;

                          ;c = c SHR 3, convert y pixel to y tile.
    srl  c                ;
    srl  c                ;
    srl  c                ;

                          ;hl = 20 * c
    ld   b,0              ;
    ld   hl,0             ;
    ld   a,20             ;
MulLoop2:                 ;
    add  hl,bc            ;
    dec  a                ;
    cp   0                ;
    jr   nz,MulLoop2      ;

                          ;Load cursor x coordinate from RAM.
    push hl               ;
    ld   hl,$c100         ;
    ld   a,(hl)           ;
    ld   c,a              ;
    pop  hl               ;

                          ;c = c SHR 3, convert x pixel to x tile.
    srl  c                ;
    srl  c                ;
    srl  c                ;

                          ;hl = hl + c
    ld   b,0              ;
    add  hl,bc            ;

                          ;hl = hl - 66
    ld   bc,66            ;
    scf                   ;Set carry flag
    ccf                   ;Complement carry flag
    sbc  hl,bc            ;


                          ;hl = 32 * hl
    ld   b,h              ;
    ld   c,l              ;
    ld   hl,0             ;
    ld   a,32             ;
MulLoop3:                 ;
    add  hl,bc            ;
    dec  a                ;
    cp   0                ;
    jr   nz,MulLoop3      ;

    ;Now hl = address in VRAM of the first byte of the tile the cursor is on.



                          ;Load cursor y coordinate from RAM.
    push hl               ;
    ld   hl,$c101         ;
    ld   a,(hl)           ;
    pop  hl               ;

                          ;Figure out address of required row in tile.
    rl   a                ;
    rl   a                ;
    and  28               ;a = a and 00011100
    ld   c,a              ;
    ld   b,0              ;
    add  hl,bc            ;hl = address of first of 4 bytes of row.


                          ;Load cursor x coordinate from RAM.
    push hl               ;
    ld   hl,$c100         ;
    ld   a,(hl)           ;
    and  7                ;a = a and 00000111 (subtile x coordinate)
    ld   c,a              ;
    pop  hl               ;
    


                          ;Set VRAM address of the first byte of the row.
    ld   a,l              ;
    out  ($bf),a          ;
    ld   a,h              ;
    add  a,$40            ;
    out  ($bf),a          ;

    in   a,($be)          ;Discard first byte read, seems to be always 0.
    in   a,($be)          ;Read current value
    ld   b,a

                          ;Set the (7-c)th bit in b, ie the bit of the cth
                          ; pixel from the left.
    ld   a,c              ;
    cp   0                ;
    jp   nz,PNTnot0       ;
    set  7,b              ;
PNTnot0:                  ;
    cp   1                ;
    jp   nz,PNTnot1       ;
    set  6,b              ;
PNTnot1:                  ;
    cp   2                ;
    jp   nz,PNTnot2       ;
    set  5,b              ;
PNTnot2:                  ;
    cp   3                ;
    jp   nz,PNTnot3       ;
    set  4,b              ;
PNTnot3:                  ;
    cp   4                ;
    jp   nz,PNTnot4       ;
    set  3,b              ;
PNTnot4:                  ;
    cp   5                ;
    jp   nz,PNTnot5       ;
    set  2,b              ;
PNTnot5:                  ;
    cp   6                ;
    jp   nz,PNTnot6       ;
    set  1,b              ;
PNTnot6:                  ;
    cp   7                ;
    jp   nz,PNTnot7       ;
    set  0,b              ;
PNTnot7:                  ;

                          ;Set VRAM address of the first byte of the row.
    ld   a,l              ;
    out  ($bf),a          ;
    ld   a,h              ;
    add  a,$40            ;
    out  ($bf),a          ;

    ld   a,b
    out  ($be),a          ;Write modified value back to VRAM
    out  ($be),a          ;Write the same byte to each of the
    out  ($be),a          ; four bytes in the row to make a 0/15
    out  ($be),a          ;  = black/white row of pixels.



PNTpaintnotpressed:

                          ;Load cursor coordinates from RAM.
    ld   hl,$c100         ;
    ld   a,(hl)           ;
    sub  3                ;
    ld   b,a              ;
    inc  hl               ;
    ld   a,(hl)           ;
    sub  4                ;
    ld   c,a              ;

                          ;Set coordinates of cursor
    ld   a,$80            ;Set VRAM address to x-coordinate
    out  ($bf),a          ;
    ld   a,$7F            ;
    out  ($bf),a          ;
    ld   a,b              ;
    out  ($be),a          ;x pos
                          ;
    ld   a,$00            ;Set VRAM address to y-coordinate
    out  ($bf),a          ;
    ld   a,$7f            ;
    out  ($bf),a          ;
    ld   a,c              ;
    out  ($be),a          ;y pos



    jp   PNTloop



crosshairdata:
    .byte    016, 016, 000, 016       ; Row 0
    .byte    016, 016, 000, 016       ; Row 1
    .byte    000, 000, 000, 000       ; Row 2
    .byte    198, 198, 000, 198       ; Row 3
    .byte    000, 000, 000, 000       ; Row 4
    .byte    016, 016, 000, 016       ; Row 5
    .byte    016, 016, 000, 016       ; Row 6
    .byte    000, 000, 000, 000       ; Row 7


;============================================================================
;============================/\= PAINT =/\===================================
;============================================================================

;============================================================================
;=============================\/= TEXT =\/===================================
;============================================================================
text:

    ld   sp,$c0ff         ;Set 256 byte stack

    ld   b,$c0
    call waitforline
                          ;Initialise the VDP registers.
    ld   hl,VDPRegsTable  ;
    ld   b,$0b            ;11 registers.
    ld   c,$80            ;Set VDP register address to 0 ($80+0)
TXTVDPRegsLoop:           ;
    ld   a,(hl)           ;
    inc  hl               ;
    out  ($bf),a          ;Send data to register.
    ld   a,c              ;
    inc  c                ;
    out  ($bf),a          ;Send register address.
    dec  b                ;
    jr   nz,TXTVDPRegsLoop;

                          ;Set palette
    ld   a,0              ;Set CRAM address to $00 (color 0).
    out  ($bf),a          ;
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   hl,PaletteData   ;
    ld   c,64             ;Write 64 bytes to the palette registers for the
TXTPaletteLoop:           ; 32 colors (2 bytes per palette entry).
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  c                ;
    ld   a,0              ;
    or   c                ;
    jr   nz,TXTPaletteLoop;


                          ;Fill entire VRAM with zeros.
    ld   a,$00            ;Set VRAM address to $0000
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   bc,$4000         ;
TXTClearVRAMLoop:         ;
    ld   a,0              ;
    out  ($be),a          ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,TXTClearVRAMLoop;


                          ;Transfer tiles to VRAM
    ld   a,$00            ;Set VRAM address to $0000 (tile images)
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   hl,TileData      ;
    ld   bc,TileCount     ;
TXTTileLoop:              ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send one byte of a tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,TXTTileLoop   ;


                          ;Turn on the Screen.
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   a,$81            ;
    out  ($bf),a          ;Write to VDP register 1.




    ld   hl,TXTTileNums   ;hl counts the source address.
TXTpageloop:

    push bc               ;
    ld   b,$c0            ;
    call waitforline      ;
    pop  bc               ;

                          ;Transfer tile numbers to VRAM
    ld   a,$CC            ;Set VRAM address to $3800 (start of 1st GG tile row)
    out  ($bf),a          ;
    ld   a,$78            ;
    out  ($bf),a          ;
    ld   b,9              ;b counts the row number (backwards).
TXTTileNumLoop:           ;

                          ;Fill in one GG row of text.
    push bc               ;
    ld   b,20             ;b counts the column number (backwards)
    ld   c,$be            ;
    sub  a                ;
TXTTile2:                 ;
    outi                  ;out (c), (hl)   inc hl,  dec b
    out  ($be),a          ;Send high byte, always 0.
    jr   nz,TXTTile2      ;
    pop  bc               ;

                          ;Add 6 tiles off right hand side of current row
                          ; and 6 off left hand side of the next row.
    ld   d,24             ;
    sub  a                ;
TXTEdgeFillLoop:          ;
    out  ($be),a          ;
    dec  d                ;
    jr   nz,TXTEdgeFillLoop;


    dec  b                ;
    jr   nz,TXTTileNumLoop;


    push bc               ;
    ld   b,$c0            ;
    call waitforline      ;
    pop  bc               ;


    ld   b,9              ;b counts the row number (backwards).
TXTTileNumLoop3:          ;

                          ;Fill in one GG row of text.
    push bc               ;
    ld   b,20             ;b counts the column number (backwards)
    ld   c,$be            ;
    sub  a                ;
TXTTile3:                 ;
    outi                  ;out (c), (hl)   inc hl,  dec b
    out  ($be),a          ;Send high byte, always 0.
    jr   nz,TXTTile3      ;
    pop  bc               ;

                          ;Add 6 tiles off right hand side of current row
                          ; and 6 off left hand side of the next row.
    ld   d,24             ;
    sub  a                ;
TXTEdgeFillLoop3:         ;
    out  ($be),a          ;
    dec  d                ;
    jr   nz,TXTEdgeFillLoop3;


    dec  b                ;
    jr   nz,TXTTileNumLoop3;



                          ;Return hl to what it was at the start of the loop.
    ld   bc,360           ;
    scf                   ;
    ccf                   ;
    sbc  hl,bc            ;



TXTbuttonwait:

    in   a,($dc)          ;Read data from button port.
    bit  1,a              ;
    jp   z,TXTforward     ;
    bit  0,a              ;
    jp   z,TXTback        ;

    in   a,($00)          ;Read from start button port.
    bit  7,a              ;
    jp   z,gui            ;Bugger off back to the GUI bit if start is pressed.

    jp   TXTbuttonwait    ;


                          ;Go back
TXTback:                  ;
    ld   bc,20            ;
    scf                   ;
    ccf                   ;
    sbc  hl,bc            ;
                          ;Check if it's gone past the beginning of the text.
    ld   bc,TXTTileNums   ;
    ld   a,b              ;
    cp   h                ;
    jp   m,TXTbackok      ;
    ld   a,c              ;
    cp   l                ;
    jp   m,TXTbackok      ;
                          ;
    ld   hl,TXTTileNums   ;
                          ;
TXTbackok:                ;
    jp TXTpageloop        ;

                          ;Go forward
TXTforward:               ;
    ld   bc,20            ;
    scf                   ;
    ccf                   ;
    adc  hl,bc            ;
                          ;Check if it's gone past the end of the text.
    ld   bc,TXTTileEnd-360;
    ld   a,h              ;
    cp   b                ;
    jp   m,TXTfwdok       ;
    ld   a,l              ;
    cp   c                ;
    jp   m,TXTfwdok       ;
                          ;Set HL to the highest allowable value.
    ld   hl,TXTTileEnd    ;
    ld   bc,360           ;
    scf                   ;
    ccf                   ;
    sbc  hl,bc            ;
TXTfwdok:                 ;
    jp TXTpageloop        ;


TXTTileNums:
 
    .byte "HELLO, THIS IS MY   "
    .byte "EXPERIMENTAL GAME   "
    .byte "GEAR PROGRAM, WINGG-"
    .byte "WINDOWS FOR THE GG. "
    .byte "                    "
    .byte "PRESS UP AND DOWN TO"
    .byte "SCROLL THROUGH THIS."
    .byte "                    "
    .byte "HERE'S SOME INFO ON "
    .byte "THE GAME GEAR:      "
    .byte "                    "
    .byte "CPU: Z80 @ 3.58MHZ  "
    .byte "RESOLUTION: 160*144 "
    .byte "COLOUR PALETTE SIZE:"
    .byte " 16 FOR SPRITES,    "
    .byte " 16 FOR BACKGROUND. "
    .byte "COLOURS AVAILABLE:  "
    .byte " 4096               "
    .byte "MAIN RAM: 8K        "
    .byte "VIDEO RAM: 16K      "
    .byte "                    "
    .byte "CARTRIDGE PINOUT:   "
    .byte "1    +34V           "
    .byte "2    +5V            "
    .byte "3    ^WR            "
    .byte "4    A12            "
    .byte "5    A7/CL1B3       "
    .byte "6    A6/CL1A2       "
    .byte "7    A5/CL1B2       "
    .byte "8    A4/CL1A1       "
    .byte "9    A3/CL1B1       "
    .byte "10   A2/DW          "
    .byte "11   A1/DO3         "
    .byte "12   A0/DO1         "
    .byte "13   D0/DB          "
    .byte "14   D1/P3          "
    .byte "15   D2/P2          "
    .byte "16   GROUND         "
    .byte "17   GROUND         "
    .byte "18   GROUND         "
    .byte "19   D3/P4          "
    .byte "20   D4/P1          "
    .byte "21   D5/CL2         "
    .byte "22   D6/DO2         "
    .byte "23   D7/DO4         "
    .byte "24   ^MREQ          "
    .byte "25   A10/TPR2       "
    .byte "26   ^RD            "
    .byte "27   ^M0000-7FFF    "
    .byte "28   A15            "
    .byte "29   A11            "
    .byte "30   A9/TPR1        "
    .byte "31   A8/CL1A3       "
    .byte "32   A13            "
    .byte "33   A14            "
    .byte "34   ^M8000-BFFF    "
    .byte "35   +5V            "
    .byte "36   ^M1 M1 CYCLE   "
    .byte "37   I/O REQUEST    "
    .byte "38   ^REFRESH       "
    .byte "39   ^RESET         "
    .byte "40   CLOCK          "
    .byte "41   GROUND         "
    .byte "42   MS/^GG         "
    .byte "43   ^TV            "
    .byte "44   TV SOUND RIGHT "
    .byte "45   TV SOUND LEFT  "
    .byte "                    "
    .byte "                    "
    .byte "BY:  VICTOR KEMP,   "
    .byte "    NOVEMBER 1999.  "
    .byte "                    "
    .byte "EMAIL:              "
    .byte "       VKEMP@       "
    .byte "  PARADISE.NET.NZ   "
    .byte "                    "
    .byte "WEB:                "
    .byte "       HTTP://      "
    .byte " HOMEPAGES.PARADISE."
    .byte " NET.NZ/^VKEMP/SEGA "
    .byte "                    "

TXTTileEnd:

;============================================================================
;=============================/\= TEXT =/\===================================
;============================================================================

;============================================================================
;===========================\/= ANIMATION =\/================================
;============================================================================
animation:

    ld   sp,$c0ff         ;Set 256 byte stack

    ld   b,$c0
    call waitforline
                          ;Initialise the VDP registers.
    ld   hl,VDPRegsTable  ;
    ld   b,$0b            ;11 registers.
    ld   c,$80            ;Set VDP register address to 0 ($80+0)
ANMVDPRegsLoop:           ;
    ld   a,(hl)           ;
    inc  hl               ;
    out  ($bf),a          ;Send data to register.
    ld   a,c              ;
    inc  c                ;
    out  ($bf),a          ;Send register address.
    dec  b                ;
    jr   nz,ANMVDPRegsLoop;

                          ;Set palette
    ld   a,0              ;Set CRAM address to $00 (color 0).
    out  ($bf),a          ;
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   hl,ANMPaletteData;
    ld   c,64             ;Write 64 bytes to the palette registers for the
ANMPaletteLoop:           ; 32 colors (2 bytes per palette entry).
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  c                ;
    ld   a,0              ;
    or   c                ;
    jr   nz,ANMPaletteLoop;

                          ;Fill entire VRAM with zeros.
    ld   a,$00            ;Set VRAM address to $0000
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   bc,$4000         ;
ANMClearVRAMLoop:         ;
    ld   a,0              ;
    out  ($be),a          ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,ANMClearVRAMLoop;










                          ;Transfer tile numbers to VRAM
    ld   a,$40            ;Set VRAM address to $3b40 (start of 10th tile row)
    out  ($bf),a          ;
    ld   a,$7b            ;
    out  ($bf),a          ;
                          ;
    ld   c,9              ;9 rows
ANMTileRowLoop:           ;
                          ;
    ld   b,32             ;
ANMTileNumLoop:           ;
    ld   hl,randomtilenums;
                          ;

                          ;Set a to an even random number from 0-62
    push hl               ;
    push bc               ;
    ld   hl,randomtiles   ;
    ld   a,c              ;
    sla  a                ;
    sla  a                ;
    sla  a                ;
    sla  a                ;
    sla  a                ;
    add  a,b              ;
    ld   c,a              ;
    ld   b,0              ;
    add  hl,bc            ;
    ld   a,(hl)           ;Get a byte from the random number table
    and  62               ;Make it even and from 0-62
    pop  bc               ;
    pop  hl               ;

    push bc               ;
    ld   c,a              ;
    ld   b,0              ;
    add  hl,bc            ;
    pop  bc               ;
                          ;
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    ld   a,(hl)           ;
    out  ($be),a          ;
    dec  b                ;
    jr   nz,ANMTileNumLoop;
                          ;
    dec  c                ;
    jp   nz,ANMTileRowLoop;


                          ;Transfer tiles to VRAM
    ld   a,$20            ;Set VRAM address to $0020 (tile images)
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   hl,randomtiles   ;8*32 random bytes
    ld   bc,288           ;8(9??) tiles, 1/4 row. 4 flip directions makes 32.
ANMTileLoop:              ;
    ld   a,(hl)           ;Get some random data 
    out  ($be),a          ;Send one byte of a tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,c              ;
    or   b                ;
    jr   nz,ANMTileLoop   ;


                          ;Transfer sky tile to VRAM
    ld   a,$00            ;Set VRAM address to $0000 (tile 0 image)
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;
    ld   hl,SkyTileData   ;
    ld   bc,32            ;
ANMTileLoop5:             ;
    ld   a,(hl)           ;
    out  ($be),a          ;Send one byte of a tile.
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,ANMTileLoop5  ;


                          ;Turn on the Screen.
    ld   a,$c0            ;
    out  ($bf),a          ;
    ld   a,$81            ;
    out  ($bf),a          ;Write to VDP register 1.



    ld   c,104            ;c = line number
ANMloop:

    in   a,($00)          ;Read data from start button port.
    bit  7,a        
    jp   z,gui            ;Reload the GUI if start pressed.

    ld   a,c
    sub  1
    ld   b,a
    call waitforline      ;Wait for line c-1 (so it will act on line c).

    ld   hl,$c100
    ld   b,0
    add  hl,bc
    ld   a,(hl)
                          ;Write new scroll offset 'a' for line 'c'.
    out  ($bf),a          ;
    ld   a,$88            ;
    out  ($bf),a          ;Write to VDP register 8.

    inc  c
    ld   a,169
    cp   c
    jp   nz,ANMloop


    ld   hl,$c164
    ld   a,(hl)
                          ;Write new scroll offset 'a' for lines 0-100.
    out  ($bf),a          ;
    ld   a,$88            ;
    out  ($bf),a          ;Write to VDP register 8.


                          ;Update all scroll offsets.
    ld   c,104

                          ;delay, not a nice way of slowing it down,
                          ; just reduces the frame rate.
    inc  d                ;
    ld   a,1              ;
    and  d                ;
    jp   nz,ANMloop       ;


    push bc
    ld   c,100
ANMincloop:
                          ;Read offset from RAM
    ld   hl,$c100         ;
    ld   b,0              ;
    add  hl,bc            ;
    ld   a,(hl)           ;

    push bc
    push af
    ld   a,c
    sub  96
    ld   c,a
    pop  af
    srl  c
    srl  c
    sub  c
    pop  bc

                          ;Write new offset back to RAM
    ld   hl,$c100         ;
    ld   b,0              ;
    add  hl,bc            ;
    ld   (hl),a           ;

    inc  c
    ld   a,c
    cp   168
    jp   nz,ANMincloop

    inc  e

    pop  bc

    jp   ANMloop


ANMPaletteData:
.include 3dpal
.include spalette

randomtiles:
.include rand256

randomtilenums:
    .byte $04, $02
    .byte $06, $00
    .byte $09, $00
    .byte $01, $00
    .byte $08, $06
    .byte $03, $02
    .byte $06, $06
    .byte $06, $06

    .byte $07, $06
    .byte $02, $00
    .byte $09, $00
    .byte $04, $06
    .byte $06, $02
    .byte $02, $02
    .byte $07, $06
    .byte $03, $00

    .byte $03, $06
    .byte $06, $02
    .byte $02, $00
    .byte $05, $06
    .byte $02, $02
    .byte $07, $02
    .byte $01, $00
    .byte $02, $06

    .byte $03, $00
    .byte $09, $00
    .byte $05, $04
    .byte $03, $04
    .byte $02, $06
    .byte $07, $02
    .byte $06, $04
    .byte $03, $06


SkyTileData:
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0
    .byte 0,0,255,0

;============================================================================
;===========================/\= ANIMATION =/\================================
;============================================================================

;============================================================================
;============================\/= PICTURE =\/=================================
;============================================================================
picture:

    ld   sp,$c0ff         ;Set 256 byte stack

    ld   b,$c0
    call waitforline

    ld   hl,VDPRegsTable  ;Set 11 VDP registers.
    ld   b,$0b            ;  
    ld   c,$80            ;  Set VDP register address to 0 ($80+0)
PICVDPRegsLoop:           ;
    ld   a,(hl)           ;
    inc  hl               ;
    out  ($bf),a          ;  Send data to register.
    ld   a,c              ;
    inc  c                ;
    out  ($bf),a          ;  Send register address.
    dec  b                ;
    jr   nz,PICVDPRegsLoop;


    sub  a                ;Set CRAM address to $00 (color 0).
    out  ($bf),a          ;
    ld   a,$c0            ;
    out  ($bf),a          ;

    ld   hl,PICPaletteData;Write 32 bytes to the palette registers for the
    ld   c,32             ;16 tile colors (2 bytes per palette entry).
PICPaletteLoop:           ;
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  c                ;
    ld   a,0              ;
    or   c                ;
    jr   nz,PICPaletteLoop;


    ld   a,$00            ;Set VRAM address to $0000
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;

    ld   bc,$4000         ;Fill entire VRAM with zeros.
PICClearVRAMLoop:         ;
    sub  a                ;
    out  ($be),a          ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,PICClearVRAMLoop;


    ld   a,$00            ;Set VRAM address to $0000 (tile images)
    out  ($bf),a          ;
    ld   a,$40            ;
    out  ($bf),a          ;

    ld   hl,PICTileData   ;Transfer tiles to VRAM
    ld   bc,PICTileCount  ;
PICTileLoop:              ;
    ld   a,(hl)           ;
    out  ($be),a          ;
    inc  hl               ;
    dec  bc               ;
    ld   a,b              ;
    or   c                ;
    jr   nz,PICTileLoop   ;






    ld   a,$cc            ;Set VRAM address to $38cc (start of 1st tile row)
    out  ($bf),a          ;
    ld   a,$78            ;
    out  ($bf),a          ;

    ld   c,0              ;c counts the row number of tiles (0-17)
PICScreenLoop2:

    ld   b,0              ;b is the column number (0-19)
PICScreenLoop1:

    push bc               ;hl = 20 * c
    ld   b,0              ;Is it just me or is there no multiply instruction
    ld   hl,0             ;on the Z80?!!? And to really twist the knife
    ld   d,20             ;there's no 16 bit left shift instruction to use
PICMulLoop1:              ;instead either! Well using a loop is still a
    add  hl,bc            ;pretty slow way to multiply but it's easy.
    dec  d                ;
    ld   a,d              ;
    cp   0                ;
    jr   nz,PICMulLoop1   ;
    pop  bc               ;

    push bc               ;hl = hl + b
    ld   c,b              ;
    ld   b,0              ;
    add  hl,bc            ;
    pop  bc               ;

    ld   a,l              ;Write tile number (hl) to VRAM
    out  ($be),a          ;
    ld   a,h              ;
    out  ($be),a          ;

    inc  b                ;Move to the next tile along
    ld   a,b              ;
    cp   20               ;
    jr   nz,PICScreenLoop1;

    ld   d,24             ;Add 6 tiles off right hand side of current row
PICEdgeFillLoop:          ;and 6 off left hand side of the next row.
    ld   a,0              ;
    out  ($be),a          ;
    dec  d                ;
    ld   a,0              ;
    cp   d                ;
    jr   nz,PICEdgeFillLoop;

    inc  c                ;Move to the next row of tiles.
    ld   a,c              ;
    cp   18               ;
    jr   nz,PICScreenLoop2;



    ld   a,$c0            ;Turn on the Screen(bit 7 must be 1, why?)
    out  ($bf),a          ;
    ld   a,$81            ;
    out  ($bf),a          ;



PICEndlessLoop:

    in   a,($00)          ;Read data from start button port.
    bit  7,a        
    jp   z,gui            ;Reload the GUI

    jp   PICEndlessLoop


PICPaletteData:
.include picpal

PICTileData:
.include pictiles
PICTileEnd:
PICTileCount = PICTileEnd-PICTileData


;============================================================================
;============================/\= PICTURE =/\=================================
;============================================================================


waitforline:               ;Subroutine which waits for specified(b) scanline.
    push af                ;  Better not modify any registers.
waitforline2:              ;
    in   a,($7e)           ;  7eh is the current displayed scanline.
    cp   b                 ;  Waits for specified line.
    jr   nz,waitforline2   ;
    pop  af                ;
    ret                    ;


                           ;checks if d<b<e.
isbbetween:                ;
    ld   a,b               ;
    cp   d                 ;
    jp   m,bfail           ;
    ld   a,e               ;
    cp   b                 ;
    jp   m,bfail           ;
    jp   bpass             ;
bfail:                     ;
    ld   a,0               ;Return a=0 if it's in the range.
    ret                    ;
bpass:                     ;
    ld   a,1               ;Return a=1 if it's not in the range.
    ret                    ;

                           ;checks if d<c<e.
iscbetween:                ;
    ld   a,c               ;
    cp   d                 ;
    jp   m,cfail           ;
    ld   a,e               ;
    cp   c                 ;
    jp   m,cfail           ;
    jp   cpass             ;
cfail:                     ;
    ld   a,0               ;Return a=0 if it's in the range.
    ret                    ;
cpass:                     ;
    ld   a,1               ;Return a=1 if it's not in the range.
    ret                    ;


PaletteData:
.include palette
.include spalette


VDPRegsTable:
;VDP registers: 0   1   2   3   4   5   6   7   8   9   10
       .byte    $06,$80,$ff,$ff,$ff,$ff,$ff,$00,$00,$00,$00



.org $7FF0
        .DB "TMR SEGA"  ; Tradmark 
        .DW 8619h       ; Year
        .DW 0FFFFh      ; Checksum, doesn't seem to be used on GG
        .DW 4081h       ; Part Num (2nd byte (MSB) = 40 -> 32k Card) 
        .DW 4C00h       ; ???

.org $8000
.end
